HDU 3342 Legal or Not (拓扑排序)

Legal or Not

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 10396    Accepted Submission(s): 4869


Problem Description
ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not. 

Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.
 

Input
The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0.
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.
 

Output
For each test case, print in one line the judgement of the messy relationship.
If it is legal, output "YES", otherwise "NO".
 

Sample Input
 
  
3 20 11 22 20 11 00 0
 

Sample Output
 
  
YESNO


题意:输入数据nm,表示有n个人接下来m行,每行输入xy表示xy的师父;如果AB的师父BC的师父,则AC的师父
如果AB的师父,B又是A的师父则不合法输出No,如果合法输出YES

 

思路:判断他们之间的关系是否形成一个环形,拓扑排序,接着判断是否全部入度( in )都被消掉为 0. (方法可能比较笨)
#include<bits/stdc++.h>

using namespace std;
int n,m;
int in[110];
bool vis[110];
int maps[110][110];

int main(){
	int x,y;
	while(~scanf("%d%d",&n,&m)){
		memset(maps,0,sizeof maps);
		memset(in,0,sizeof in);
		memset(vis,0,sizeof vis);
		if(n==0 && m==0) break;
		for(int i=1;i<=m;i++){
			scanf("%d%d",&x,&y);
			if(maps[x][y]==0){
				maps[x][y]=1;
				in[y]++;
			}
		}
		while(1){
			int p=n;	
			for(int i=0;i<n;i++){
				if(in[i]==0){
					p=i;
					in[i]=-1;
					break;
				}
			}
			if(p==n) break;
			for(int j=0;j<n;j++){
				if(maps[p][j]){
					maps[p][j]=0;
					in[j]--;
				}
			}
		}
	//判断入度是否都为0
		int f=0;
		for(int i=0;i<n;i++){
			if(in[i]!=-1){
				f=1;
				break;
			}
		}
		if(f) printf("NO\n");
		else printf("YES\n");
	}
}


猜你喜欢

转载自blog.csdn.net/rvelamen/article/details/80621334
今日推荐